# phpDox - Source of SQL.php

# Source of file SQL.php

Size: 5,473 Bytes - Last Modified: 2020-04-10T20:54:13-04:00

## src/Drivers/Pgsql/SQL.php

1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277

    <?php declare(strict_types=1);

    /**

     * Query

     *

     * SQL Query Builder / Database Abstraction Layer

     *

     * PHP version 7.4

     *

     * @package     Query

     * @author      Timothy J. Warren <tim@timshomepage.net>

     * @copyright   2012 - 2020 Timothy J. Warren

     * @license     http://www.opensource.org/licenses/mit-license.html  MIT License

     * @link        https://git.timshomepage.net/aviat/Query

     * @version     3.0.0

     */

    namespace Query\Drivers\Pgsql;

    use Query\Drivers\AbstractSQL;

    /**

     * PostgreSQL specific SQL

     */

    class SQL extends AbstractSQL {

    	/**

    	 * Get the query plan for the sql query

    	 *

    	 * @param string $sql

    	 * @return string

    	 */

    	public function explain(string $sql): string

    	{

    		return "EXPLAIN VERBOSE {$sql}";

    	}

    	/**

    	 * Random ordering keyword

    	 *

    	 * @return string

    	 */

    	public function random(): string

    	{

    		return ' RANDOM()';

    	}

    	/**

    	 * Returns sql to list other databases

    	 *

    	 * @return string

    	 */

    	public function dbList(): string

    	{

    		return <<<SQL

    			SELECT "datname" FROM "pg_database"

    			WHERE "datname" NOT IN ('template0','template1')

    			ORDER BY "datname" ASC

    SQL;

    	}

    	/**

    	 * Returns sql to list tables

    	 *

    	 * @return string

    	 */

    	public function tableList(): string

    	{

    		return <<<SQL

    			SELECT "table_name"

    			FROM "information_schema"."tables"

    			WHERE "table_type" = 'BASE TABLE'

    			AND "table_schema" NOT IN

    				('pg_catalog', 'information_schema');

    SQL;

    	}

    	/**

    	 * Returns sql to list system tables

    	 *

    	 * @return string

    	 */

    	public function systemTableList(): string

    	{

    		return <<<SQL

    			SELECT "table_name"

    			FROM "information_schema"."tables"

    			WHERE "table_type" = 'BASE TABLE'

    			AND "table_schema" IN

    				('pg_catalog', 'information_schema');

    SQL;

    	}

    	/**

    	 * Returns sql to list views

    	 *

    	 * @return string

    	 */

    	public function viewList(): string

    	{

    		return <<<SQL

    		 	SELECT "viewname" FROM "pg_views"

    			WHERE "schemaname" NOT IN

    				('pg_catalog', 'information_schema')

    			AND "viewname" !~ '^pg_'

    			ORDER BY "viewname" ASC

    SQL;

    	}

    	/**

    	 * Returns sql to list triggers

    	 *

    	 * @return string

    	 */

    	public function triggerList(): string

    	{

    		return <<<SQL

    			SELECT *

    			FROM "information_schema"."triggers"

    			WHERE "trigger_schema" NOT IN

    				('pg_catalog', 'information_schema')

    SQL;

    	}

    	/**

    	 * Return sql to list functions

    	 *

    	 * @return string

    	 */

    	public function functionList(): ?string

    	{

    		return NULL;

    	}

    	/**

    	 * Return sql to list stored procedures

    	 *

    	 * @return string

    	 */

    	public function procedureList(): string

    	{

    		return <<<SQL

    			SELECT "routine_name"

    			FROM "information_schema"."routines"

    			WHERE "specific_schema" NOT IN

    				('pg_catalog', 'information_schema')

    			AND "type_udt_name" != 'trigger';

    SQL;

    	}

    	/**

    	 * Return sql to list sequences

    	 *

    	 * @return string

    	 */

    	public function sequenceList(): string

    	{

    		return <<<SQL

    			SELECT "c"."relname"

    			FROM "pg_class" "c"

    			WHERE "c"."relkind" = 'S'

    			ORDER BY "relname" ASC

    SQL;

    	}

    	/**

    	 * Return sql to list columns of the specified table

    	 *

    	 * @param string $table

    	 * @return string

    	 */

    	public function columnList(string $table): string

    	{

    		return <<<SQL

    			SELECT ordinal_position,

    				column_name,

    				data_type,

    				column_default,

    				is_nullable,

    				character_maximum_length,

    				numeric_precision

    			FROM information_schema.columns

    			WHERE table_name = '{$table}'

    			ORDER BY ordinal_position;

    SQL;

    	}

    	/**

    	 * SQL to show list of field types

    	 *

    	 * @return string

    	 */

    	public function typeList(): string

    	{

    		return <<<SQL

    			SELECT "typname" FROM "pg_catalog"."pg_type"

    			WHERE "typname" !~ '^pg_|_'

    			AND "typtype" = 'b'

    			ORDER BY "typname"

    SQL;

    	}

    	/**

    	 * Get the list of foreign keys for the current

    	 * table

    	 *

    	 * @param string $table

    	 * @return string

    	 */

    	public function fkList(string $table): string

    	{

    		return <<<SQL

    			SELECT

    				"att2"."attname" AS "child_column",

    				"cl"."relname" AS "parent_table",

    				"att"."attname" AS "parent_column",

    				"con"."update" AS "update",

    				"con"."update" AS "delete"

    			FROM

    				(SELECT

    					unnest(con1.conkey) AS "parent",

    					unnest(con1.confkey) AS "child",

    					"con1"."confrelid",

    					"con1"."conrelid",

    					"con1"."confupdtype" as "update",

    					"con1"."confdeltype" as "delete"

    				FROM "pg_class" "cl"

    				JOIN "pg_namespace" "ns" ON "cl"."relnamespace" = "ns"."oid"

    				JOIN "pg_constraint" "con1" ON "con1"."conrelid" = "cl"."oid"

    				WHERE "cl"."relname" = '{$table}'

    					AND "ns"."nspname" = 'public'

    					AND "con1"."contype" = 'f'

    				)

    				"con"

    				JOIN "pg_attribute" "att" ON

    					"att"."attrelid" = "con"."confrelid"

    					AND "att"."attnum" = "con"."child"

    				JOIN "pg_class" "cl" ON

    					"cl"."oid" = "con"."confrelid"

    				JOIN "pg_attribute" "att2" ON

    					"att2"."attrelid" = "con"."conrelid"

    					AND "att2"."attnum" = "con"."parent"

    SQL;

    	}

    	/**

    	 * Get the list of indexes for the current table

    	 *

    	 * @param string $table

    	 * @return string

    	 */

    	public function indexList(string $table): string

    	{

    		return <<<SQL

    			SELECT

    				t.relname AS table_name,

    				i.relname AS index_name,

    				array_to_string(array_agg(a.attname), ', ') AS column_names

    			FROM

    				pg_class t,

    				pg_class i,

    				pg_index ix,

    				pg_attribute a

    			WHERE

    				t.oid = ix.indrelid

    				AND i.oid = ix.indexrelid

    				AND a.attrelid = t.oid

    				AND a.attnum = ANY(ix.indkey)

    				AND t.relkind = 'r'

    				AND t.relname = '{$table}'

    			GROUP BY

    				t.relname,

    				i.relname

    			ORDER BY

    				t.relname,

    				i.relname;

    SQL;

    	}

    }